(define-module (ui netinst wait ajax)
    :use-module (alterator ajax)
    :use-module (alterator woo)
    :export (init))

(define (update-progress)
  (catch/message
    (lambda()
      (let* ((data (woo-read-first "/netinst/wait"))
             (status (woo-get-option data 'status)))

        (form-update-visibility '("cancel" "p") (string=? status "progress"))
        (form-update-visibility "ok" (not (string=? status "progress")))
        (form-update-visibility "f" (string=? status "fail"))
        (form-update-visibility "s" (string=? status "stopped"))
        (form-update-visibility "c" (string=? status "done"))

        (form-update-value-list '("percent" "error") data)

        (and (string=? status "progress")
             (form-set-timeout update-progress 2))
        ))))

(define (cancel-progress)
  (format #t "cancel progress...~%")
  (woo-write "/netinst/wait" 'cancel #t))

(define (ok-progress)
  (format #t "ok progress...~%")
  (form-replace "/netinst"))

(define (init)
  (update-progress)
  (form-bind "cancel" "click" cancel-progress)
  (form-bind "ok" "click" ok-progress))
